#!coding=utf-8

from io import open as iopen

from flask import Flask
from flask import send_file
from flask import render_template
from flask import request
from flask import url_for
from flask import redirect

import requests
from pyquery import PyQuery


app = Flask(__name__)
COOIKE = None
FORM_DATA = None
CODE_FILE_NAME = 'code.gif'


def requests_image(url, headers, params=None):
    if params:
        i = requests.get(url, headers=headers, parmas=params)
    else:
        i = requests.get(url, headers=headers)
    if i.status_code == requests.codes.ok:
        with iopen(CODE_FILE_NAME, 'wb') as f:
            f.write(i.content)


def data_from_remote():
    global COOIKE
    global FORM_DATA
    site = 'http://zgcx.nhfpc.gov.cn/doctorsearch.aspx'
    r = requests.get(site)
    cookie = r.headers['Set-Cookie'].split(';')[0]
    COOIKE = cookie
    data = r.content
    pq = PyQuery(data)
    FORM_DATA = {
        '__VIEWSTATE': pq.find('#__VIEWSTATE').attr('value'),
        '__VIEWSTATEGENERATOR': pq.find('#__VIEWSTATEGENERATOR').attr('value'),
        '__EVENTVALIDATION': pq.find('#__EVENTVALIDATION').attr('value'),
        'ctl00$ContentPlaceHolder1$ButtonSearch': u'查询',
    }
    headers = {
        'Cookie': cookie,
    }
    requests_image('http://zgcx.nhfpc.gov.cn/pn.aspx', headers=headers)


@app.route('/zige')
def zige():
    data_from_remote()
    return render_template('yishizige.html')


@app.route('/info')
def info():
    return render_template('result.html')


@app.route('/info', methods=['POST'])
def post_info():
    global COOIKE
    global FORM_DATA
    for k in request.form.keys():
        FORM_DATA[k] = request.form[k]
    headers = {
        'Cookie': COOIKE,
        'User-Agent': 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_11_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/56.0.2924.87 Safari/537.36',
        'Origin': 'http://zgcx.nhfpc.gov.cn',
        'Referer': 'http://zgcx.nhfpc.gov.cn/doctorsearch.aspx',
        'Content-Type': 'application/x-www-form-urlencoded',
        'Host': 'zgcx.nhfpc.gov.cn',
        'Accept': 'text/html,application/xhtml+xml,application/xml;q=0.9,image/webp,*/*;q=0.8',
        'Accept-Encoding': 'gzip, deflate',
    }
    url = 'http://zgcx.nhfpc.gov.cn/doctorsearch.aspx'
    d = requests.post(url, headers=headers, data=FORM_DATA)
    file_name = 'templates/result.html'
    with iopen(file_name, 'wb') as f:
        f.write(d.content)

    return redirect(url_for('info'))


@app.route('/code.gif')
def code():
    return send_file(CODE_FILE_NAME, mimetype='image/gif')


if __name__ == '__main__':
    config = dict(
        debug=True,
        host='127.0.0.1',
        port=3000,
    )
    app.run(**config)
